#########################################
filepath <- "/esarchive/scratch/erifarov/git/cstools/R/"
f <- list.files(filepath)  
ff <- lapply(f, function(x) paste0(filepath, x))  
invisible(lapply(ff,source))
lib <- c('parallel', 'abind', 'bigmemory', 'future', 'multiApply', 'ClimProjDiags', 'stats', 's2dv')
invisible(lapply(lib, library, character.only = TRUE))

load("/esarchive/scratch/erifarov/git/cstools/data/lonlat_prec.rda")
load("/esarchive/scratch/erifarov/git/cstools/data/lonlat_temp.rda")

library(ncdf4)
library(s2dv)
library(startR)
library(easyNCDF)
library(lubridate)
#########################################

destination = "/esarchive/scratch/erifarov/rpackages/cstools-local/dev-CST-new-s2dv_cube/dev-SaveExp/develop-timedims"

CST_SaveExp(data = lonlat_prec, destination = destination, 
            ftime_dim = 'ftime', var_dim = NULL, single_file = TRUE, extra_string = 'lonlat_prec')

CST_SaveExp(data = lonlat_temp$obs, destination = destination, 
            ftime_dim = 'ftime', var_dim = NULL, single_file = TRUE, 
            extra_string = 'lonlat_temp_obs')
Rprof(memory.profiling = TRUE)
CST_SaveExp(data = lonlat_temp$exp, destination = destination, 
            ftime_dim = 'ftime', var_dim = NULL, single_file = TRUE, 
            extra_string = 'lonlat_temp_exp')
Rprof(NULL)
summaryRprof()

repos <- '/esarchive/exp/ecmwf/system5_m1/monthly_mean/$var$_f6h/$var$_$sdate$.nc'
data1 <- Start(dat = repos,
              var = 'tas',
              sdate = c('20170101', '20180101'),
              ensemble = indices(1:20),
              time = 'all',
              latitude = 'all',
              longitude = indices(1:40),
              return_vars = list(latitude = 'dat', longitude = 'dat', time = 'sdate'),
              retrieve = TRUE)
obj1 <- as.s2dv_cube(data1)
Rprof(memory.profiling = TRUE)
CST_SaveExp(obj1, destination = destination, single_file = TRUE,  
            dat_dim = 'dat', memb_dim = 'ensemble', extra_string = 'start')
Rprof(NULL)
summaryRprof(memory = "both")

### single_file = FALSE
Rprof(memory.profiling = TRUE)
CST_SaveExp(obj1, destination = destination, single_file = FALSE,  
            dat_dim = 'dat', memb_dim = 'ensemble', extra_string = 'start')
Rprof(NULL)
summaryRprof(memory = "both")
############################################################

# read the data

fnc <- NcOpen("/esarchive/scratch/erifarov/rpackages/cstools-local/dev-CST-new-s2dv_cube/dev-SaveExp/develop-timedims/prlr_20110301_20130301_lonlat_prec.nc")

fnc_dims <- NcReadDims(fnc)

var_names <- NcReadVarNames(fnc)

data_prlr <- NcToArray(fnc, vars_to_read = "prlr")

data_ftime <- NcToArray(fnc, vars_to_read = "ftime")

data_sdate <- NcToArray(fnc, vars_to_read = "sdate")

NcClose(fnc)


sdate_units <- attributes(data_sdate)$variables$sdate$units

# first sdate
ini_sdate <- as.Date(strsplit(sdate_units, " ")[[1]][3])
# all sdates
sdates_vector <- ini_sdate + hours(c(data_sdate))

sdates_vector[1] + days(data_ftime)

Dates <- array(dim = c(ftime = length(data_ftime), sdate = length(sdates_vector)))
class(Dates) <- 'Date'
# Dates array
for (i in 1:length(sdates_vector)) {
  Dates[, i] <- sdates_vector[i] + days(data_ftime) - days(1)
}


# Dates lonlat_prec

dates_actual <- lonlat_prec$attrs$Dates

dates_actual[,1]

Dates[,1]